# ocspkg
ocspkg, based on fedpkg's debrand, is a wrapper for rpkg which interacts with RPM git repositories like the ones hosted at http://gitee.com/src-opencloudos-rpms rpkg also provides some convenience methods/commands for local builds via mock or rpmbuild, for interacting with koji, and for generating patches.

Not all typical rpkg commands have been implemented yet.  If the command you are looking for doesn't appear to work, please open an issue.

This repository provides one executable script, ocspkg.

## 1. ocspkg

Executable ocspkg allows you to interact with OpenCloudOS Stream Linux dist-git and OpenCloudOS Stream Linux koji instance.

You can install it by executing: 
```
dnf install ocspkg
```

## 2. Supported commands

Here is the list currently supported commands by ocspkg:

- Git-like commands
    * clone
    * co: clone alias.
    * sources: download tarball.
    * upload: upload tarball, **append to the sources file**.
    * new-sources: upload tarball, **override in the sources file**.
    * diff
    * commit
    * push
- Mock-like commands:
    * prep
    * srpm
    * local: locally test run of rpmbuild producing binary RPMs.
    * mockbuild: local test build using mock.
- Koji-like commands:
    * scratch-build
    * build

## 3. Current workflow

For a user working on a package in http://gitee.com/src-opencloudos-rpms, 
the following workflow is recommended:

    # In this example a user would like to scratch-build perl
    # fork the code in your git repository to your repository

    $ ocspkg clone libev
    $ cd libev
    $ ocspkg sources
    $ # ocspkg new-sources libev-4.33.tar.gz    # not necessary, perform as required
    $ vi libev.spec 
    $ ocspkg commit -m "initial build libev.spec"
    $ ocspkg push

    # Local build
    $ ocspkg srpm/local                         # not necessary, perform as required
    $ ocspkg mockbuild

    # Tagged builds can be done also
    $ ocspkg build --scratch 
    $ ocspkg build --scratch --srpm srpm_path

